#!/bin/bash
# *****************************************************************************
# This file is part of netview 
# (an program to animate TCP/IP networks in 3D with OpenGL).
#
#    Copyright (C) 2004,2005 Stefan Ziegler.
#
#    netview is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    netview is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with netview; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# *****************************************************************************
#
pushd /tmp/netview_video/
if ls *.pnm.gz > /dev/null
then
	for i in *.pnm.gz
	do
	echo $i
	gzip -cd $i > `basename $i ".pnm.gz"`.pnm
	# ls -l `basename $i ".pnm.gz"`*
	convert `basename $i ".pnm.gz"`.pnm `basename $i ".pnm.gz"`.png
	rm `basename $i ".pnm.gz"`.pnm
	# ls -l `basename $i ".pnm.gz"`*
	done
fi
if ls *.pnm > /dev/null
then
	for j in *.pnm
	do 
	echo $j
	convert $j `basename $j ".pnm"`.png
	done
fi
declare menc_opts1="-mf fps=10 -lavcopts"
declare menc_opts2="vcodec=msmpeg4:vbitrate=3600:vhq:keyint=250"
mencoder "mf://*.png" $menc_opts1 $menc_opts2 -o film.avi -ovc lavc
popd
