/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef ACTIONS_H
#define ACTIONS_H 1

/** definiert alle Aktionen, die im Programm bekannt sind, <br>
 *  jeder Tastendruck und jeder Men&uuml;eintrag ist mit einer Aktion
 *  verbunden, beliebig anpassbar; <br>
 *  im Quelltext werden nur diese Konstanten verwendet, um die
 *  Aktionen mit Aufrufen und Wertver&auml;nderungen zu verkn&uuml;pfen; <br>
 *  siehe Key_Control::stringToAction(), Key_Control::translateKeycode(),
 *  Menu::loadXMLAction(), Menu::translateEntryValue(),
 *  Mouse::mouse_func(), Mouse::startAction(), GlutMain::display(),
 *  GlutMain::idle(), GlutMain::init(), GlutMain::startAction() */
enum	Actions { Action_Dummy, Action_Exit, Action_Show_Copyright,
		  Action_Move_Left, Action_Move_Up, Action_Move_Front,
		  Action_Move_Right, Action_Move_Down, Action_Move_Back,
		  Action_Move_Init,
		  Action_Cam_Left, Action_Cam_Right, Action_Cam_Faster,
		  Action_Cam_Slower, Action_Cam_Up, Action_Cam_Down,
		  Action_Cam_Step, Action_Cam_Stop, Action_Cam_Init,
		  Action_View_Left, Action_View_Right, Action_View_Top,
		  Action_View_Bottom, Action_View_Front, Action_View_Back,
		  Action_View_TLF, Action_View_TRF, Action_View_BRB,
		  Action_Mode_Insert, Action_Mode_Cam, Action_Mode_Move,
		  Action_Mode_Remove, Action_Mode_Info,
		  Action_Save_Net, Action_Load_Net, Action_Execute_Net,
		  Action_Execute_Net_Loop, Action_FollowP_OnOff,
		  Action_Map_OnOff, Action_Video_StartStop,
		  Action_LOD_OnOff, Action_FollowAngle_OnOff,
		  Action_View_SceneRight,
		  Action_Animation_Slower, Action_Animation_Faster
		 };

/** definiert die Textkonstanten zu den Eintr&auml;gen, mit denen die
 *  die Aktionen in den Einstellungsdateien zum Men&uuml; und zur
 *  Tastenbelegung auftauchen, <br>
 *  eingelesen in Key_Control::stringToAction() und Menu::loadXMLAction() */
const char Action_Strings[][25] =
 		{ "Action_Dummy", "Action_Exit", "Action_Show_Copyright",
		  "Action_Move_Left", "Action_Move_Up", "Action_Move_Front",
		  "Action_Move_Right", "Action_Move_Down", "Action_Move_Back",
		  "Action_Move_Init",
		  "Action_Cam_Left", "Action_Cam_Right", "Action_Cam_Faster",
		  "Action_Cam_Slower", "Action_Cam_Up", "Action_Cam_Down",
		  "Action_Cam_Step", "Action_Cam_Stop", "Action_Cam_Init",
		  "Action_View_Left", "Action_View_Right", "Action_View_Top",
		  "Action_View_Bottom", "Action_View_Front", "Action_View_Back",
		  "Action_View_TLF", "Action_View_TRF", "Action_View_BRB",
		  "Action_Mode_Insert", "Action_Mode_Cam", "Action_Mode_Move",
		  "Action_Mode_Remove", "Action_Mode_Info",
		  "Action_Save_Net", "Action_Load_Net", "Action_Execute_Net",
		  "Action_Execute_Net_Loop", "Action_FollowP_OnOff",
		  "Action_Map_OnOff", "Action_Video_StartStop",
		  "Action_LOD_OnOff", "Action_FollowAngle_OnOff",
		  "Action_View_SceneRight",
		  "Action_Animation_Slower", "Action_Animation_Faster", ""
		 };

#endif

