/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include <vector>

#include "point_3d.h"

using namespace std;

class Bezier
/** Zusammenfassung von Methoden zur Berechnung einer Bezierkurve aus einem
 *  Feld von Hilfspunkten (control points) */
{
	private:
		static unsigned int	factorial(unsigned int x);
		static unsigned int	binomialCoefficient(unsigned int n,
							unsigned int k);
		static double		bernstein(unsigned int n,
							unsigned int i,
							double t);
	public:
		Bezier(void);
		~Bezier(void);
		static void	calcBezier(vector<Point_3D> &control_points,
					size_t num_curve_points,
					vector<Point_3D> &curve_points);
};

