/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include <netinet/igmp.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>

class Checksums
/** Zusammenfassung von mehreren Methoden zur Pr&uuml;fsummenberechnung in
 *  verschiedenen (Internet-)Protokollen,
 *  zur Zeit (getestet): IPv4, TCP und UDP und (ungetestet): ICMP und IGMPv2 */
{
	public:
		Checksums();
		~Checksums();

		static u_int16_t
			calcChecksum(const unsigned char *buffer,
					const size_t num_bytes);
		static void
			updateIpChecksum(struct ip* const ip_header);
		static void
			updateTcpChecksum(const struct ip* const ip_header,
					struct tcphdr* const tcp_header);
		static void
			updateUdpChecksum(const struct ip* const ip_header,
					struct udphdr* const udp_header);
		static void
			updateIcmpChecksum(struct icmp* const icmp_header);
		static void
			updateIgmpChecksum(struct igmp* const igmp_header);
};

