/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include <string>
#include <libxml/xmlreader.h>
#include <libxml/xmlwriter.h>

#include "packet.h"

using namespace std;

/** Gr&ouml;&szlig;e des Puffers, in dem Paket im Ausgabeformat gespeichert
 *  wird */
const size_t	packet_loader_xml_buffer_size = 100;

class Packet_Loader_XML
/** l&auml;dt Paket aus einer XML-Datei und wandelt es in eine Paketstruktur
 *  um, wie sie an den Paketserver geschickt werden kann */
{
	private:
		/** Gr&ouml;&szlig;e des Paketes in Bytes, L&auml;nge des
		 *  Paketes im Feld packet_buffer */
		size_t			packet_size;
		/** das Paket, wie es nach aussen gegeben wird */
		char			packet_buffer[
						packet_loader_xml_buffer_size];
		/** Dienstname, zu dem Paket geh&ouml;ren soll, wird bei Bedarf
		 *  (Quellportnummer == 0) im Server
		 *  (TcpQueue / UdpQueue::findServicePort()) in Portnummer
		 *  umgewandelt */
		string			service_name;
		/** Zeiger auf die eingelesene XML-Datei */
		xmlTextReaderPtr	infile;

		void		importPacket(Packet *cable_packet);
	public:
		Packet_Loader_XML(void);
		~Packet_Loader_XML(void);

		// returns true if has a packet
		bool	getPacket(char* &current_packet_buffer,
					size_t &current_packet_size,
					string &current_service_name);
		void	load(const char filename_to_load[]);
		bool	loadPacket(void);
		void	closeFile(void);
};

