/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef CAPTURE_H
#define CAPTURE_H 1

#include "pnm_image_writer.h"

class Capture
/** Die Klasse dient der Abspeicherung eines Bildes oder einer Bildsequenz
 * (f&uuml;r ein Video) vom Programmfenster */
{
	private:
					// status if capture or not
		/** Statusvariable, zeigt an ob gerade aufgenommen wird */
		bool			video_is_running;
		/** Statusvariable, zeigt an ob schon ein Bild im aktuellen
		 * Bildspeicherbereich abgelegt wurde. Wird zur&uuml;ckgesetzt
		 * nach Gr&ouml;&szlig;en&auml;nderung */
		bool			image_is_valid;
		/** Breite und H&ouml;he des zu speichernden Fensterbereiches,
		 * immer ab Position 0,0 (links unten) */
		unsigned short		width, height;
		/** die Nummer des Bildes in der aktuellen (Film-)Sequenz,
		 * genutzt im Dateinamen */
		unsigned int		frame_number;
		/** Speicherbereich des Fensterabbildes */
		char			*image;

		/** Klasse zum Abspeichern eines Bildes in einem bestimmten
		 * Dateiformat */
		PNM_Image_Writer	image_saver;

	public:	
		Capture(void);
		~Capture(void);
		void draw(void) const;
		void init(void);
		bool isRunning(void) const;
		bool isValid(void) const;
		void setSize(unsigned short new_width, 
				unsigned short new_height);
		void captureImage(void);
		bool saveImage(const char image_name[]);
		bool captureVideo(const char path_name[]);
		bool toggleRunning(void);
};

#endif

