/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef CUBOID_H
#define CUBOID_H 1

#include "point_3d.h"
#include "rectangle.h"

class Cuboid
/** Darstellung eines Quaders mit Breite 'width', H&ouml;he 'height' und 
 * Tiefe 'depth' an Position 'pos', Farbe festlegbar */ 
{
	protected:
		/** Ausma&szlig;e des Quaders */
		double 		width, height, depth;		// size
		/** Position des Quaders */
		Point_3D	pos;
		/** Fl&auml;chen des Quaders aus Rechtecken */
		class Rectangle	sides[6];
		
		void updatePos(void);
	public:
		Cuboid(void);
		~Cuboid(void);
	
		double	getWidth(void) const;	
		double	getHeight(void) const;	
		double	getDepth(void) const;	
		void	getPos(double &current_centerx, double &current_centery,
				double &current_centerz) const;
		void	setPos(double new_centerx, double new_centery, 
				double new_centerz);
		void	setSize(double new_width, double new_height,
				double new_depth);
		void	setColor(double new_red, double new_green,
				double new_blue, double new_alpha);
		void draw(void) const;
};

#endif

