/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef CYLINDER_H
#define CYLINDER_H 1

#include <GL/glu.h>

#include "point_3d.h"

class Cylinder
/** ein Zylinder oder eine Kreis-Pyramide mit Boden- und Deckfl&auml;che */
{
	private:
		/** Breite, H&ouml;he und Tiefe der Bounding-Box,
		 * Breite und Tiefe bestimmen die Grundfl&auml;che
		 * (Kreis oder Ellipse) */
		double		width, height, depth;           // size
		/** Radius der Deckfl&auml;che, 
		 * Pyramide: Radius kleiner als halbe Breite/Tiefe
		 * Zylinder: Radius gleich der halben Breite/Tiefe */
		double		top_radius;
		/** Position und Farbe des K&ouml;rpers */
		Point_3D	pos;
		/** Zeiger auf Daten zum Zeichnen des K&ouml;rpers (GLU) */
		GLUquadric	*quadric, *top, *bottom;

	public:
		Cylinder(void);
		~Cylinder(void);

                void setPos(double new_centerx, double new_centery,
                                double new_centerz);
                void setSize(double new_width, double new_height,
                                double new_depth);
		/* top_radius must be <= width / 2 */
		void setTopRadius(double new_top_radius);
                void setColor(double new_red, double new_green, double new_blue,                                double new_alpha);
                void draw(bool with_top = true) const;
};

#endif

