/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef RECTANGLE_H
#define RECTANGLE_H 1

class Rectangle
/** Darstellung eines Rechteckes inklusive Farbe */
{
	protected:
		/** linke obere und rechte untere Ecke des Rechtecks */
		double left, top, right, bottom; // position/size values
		/** Farbanteile RGBA (Rot, Grn, Blau, Alpha), 
		 * Wertebereich 0.0 - 1.0 */
		double red, green, blue, alpha;	 // color values
	public:
		/** Standard-Konstruktor: alle Variablen auf 0.0 gesetzt */
		Rectangle(void) : left(0.0), top(0.0), right(0.0), bottom(0.0),
				red(0.0), green(0.0), blue(0.0), alpha(1.0)
		{};
		/** Konstruktor: linke obere und rechte untere Ecke bergeben,
		 * Farbwerte auf 0.0 gesetzt */
		Rectangle(double new_left, double new_top, 
			  double new_right, double new_bottom):
			left(new_left), top(new_top), 
			right(new_right), bottom(new_bottom),
			red(0.0), green(0.0), blue(0.0), alpha(1.0)
		{};
		/** Destruktor: ist leer */
		~Rectangle(void) {}
		double	getWidth(void);
		double	getHeight(void);
		void 	setPos(double new_left, double new_top, 
			    	double new_right, double new_bottom);
		void 	setColor(double new_red,  double new_green, 
				double new_blue, double new_alpha);
		bool 	isInRect(double x, double y) const;
		void 	draw(void) const;
};

#endif

