/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include <iostream>
#include <netinet/in.h>

#include <libxml/xmlreader.h>
#include <libxml/xmlwriter.h>

using namespace std;

#ifndef IPADDRESS_H
#define IPADDRESS_H 1

class IpAddress
/** eine Internet-Adresse des IPv4-Protokolls, L&auml;nge: 32 Bit */
{
	private:
		/** Speicherort der Adresse */		
		struct in_addr	address;

		void	correct_iptext(char* ip_text);
	public:
		IpAddress(void);
		IpAddress(in_addr_t new_address);
		~IpAddress(void);
		void	getAddress(struct in_addr &current_address);
		char*	getAddress(void) const;
		bool	setAddress(const char *ip_string);
		void	setAddress(const struct in_addr &new_address);

		void	loadXML(xmlTextReaderPtr infile);
		void	saveXML(xmlTextWriterPtr outfile) const;

		bool operator <= (const IpAddress &right) const;
		bool operator >= (const IpAddress &right) const;
		bool operator == (const IpAddress &right) const;
		bool operator < (const IpAddress &right) const;
		bool operator > (const IpAddress &right) const;
		friend ostream& operator << (ostream &output, 
						const IpAddress &ipaddr);
		friend istream& operator >> (istream &input,
						IpAddress &ipaddr);
};

#endif

