/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include <map>

#include "actions.h"

using namespace std;

class Key_Control
/** Verarbeitung von Tastatureingaben, Verkn&uuml;pfung der Tasten mit
 *  Aktionen */
{
	private:
		/** Tabelle der Umsetzung "normale Taste zu Aktion" */
		map<unsigned char, Actions>	normal_keys;
		/** Tabelle der Umsetzung "Sondertaste zu Aktion", <br>
		 *  Sondertasten sind: F1-F12, Ins, Pos1, Ende,
		 *  Bild auf, Bild ab, Cursortasten */
		map<int, Actions>		special_keys;
		
		Actions	stringToAction(const char action_string[]);
	public:
		Key_Control(void);
		~Key_Control(void);
		void	init(void);
		bool	load(const char filename[]);
		Actions translateKeycode(unsigned char normal_key);
		Actions	translateKeycode(int special_key);
};

