/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef MACADDRESS_H
#define MACADDRESS_H 1

#include <iostream>
#include <string>
#include <net/ethernet.h>
#include <libxml/xmlreader.h>
#include <libxml/xmlwriter.h>
                                                                                
using namespace std;

class MacAddress
/** eine Adresse des Ethernet-Protokolls, L&auml;nge: 48 Bit */
{
	private:
		/** Speicherort der Adresse */
		struct ether_addr	address;
	public:
		MacAddress();
		MacAddress(const char mac_string[]);
		~MacAddress();
		void	init(void);

		void	getAddress(struct ether_addr &current_address) const;
		string	getAddress(void) const;
		bool	setAddress(const char mac_string[]);
		void	setAddress(struct ether_addr &new_address);

                void    loadXML(xmlTextReaderPtr infile);
                void    saveXML(xmlTextWriterPtr outfile) const;

                bool operator <= (const MacAddress &right) const;
                bool operator >= (const MacAddress &right) const;
                bool operator == (const MacAddress &right) const;
                friend ostream& operator << (ostream &output,
                                                const MacAddress &macaddr);
                friend istream& operator >> (istream &input,
                                                MacAddress &macaddr);
};

#endif

