/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include <map>
#include <libxml/xmlreader.h>

#include "actions.h"

using namespace std;

class Menu
/** Klasse zum Einlesen und Darstellen eines Men&uuml;s, Verkn&uuml;pfung
 *  der Men&uuml;eintr&auml;ge mit Aktionen */
{
	private:
		/** Identifikation des gesamten Men&uuml;s (menu_id) und
		*   letzte verwendete Id eines Men&uuml;eintrages
		*   (last_entry_value) */
		int			menu_id, last_entry_value;
		/** die Callback-Funktion, wird gerufen, wenn ein
		 *  Men&uuml;eintrag ausgew&auml;hlt wurde */
		void 			(* menu_callback)(int entry);
		/** Tabelle der Umsetzung 'Men&uuml;eintrag zu Aktion' */
		map<int, Actions>	menu_entry_actions;

		void	loadXMLAction(xmlTextReaderPtr infile);
		void	loadXMLEntry(xmlTextReaderPtr infile);
		void	loadXML(xmlTextReaderPtr infile);
	public:
		Menu(void);
		~Menu(void);
		void	create(void (* callback)(int entry));
		int	execute(int entry);
		void	destroy(void);
		void	loadMenu(const char filename_to_load[]);
		Actions translateEntryValue(int entry_value);
};

