/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include "interface.h"
#include "nat.h"
#include "route_table.h"

class L3_Router_ExecuteNet
/** Erweiterungsklasse zu L3_Router zur Simulation der Paketverarbeitung im
 *  Router */
{
	protected:
		/** Feld aller Netzwerkkarten im Router */
		vector<Interface*>	network_cards;
		/** die Routen-Tabelle zur Verteilung der Pakete auf die
		 *  Netzwerkkarten */
		Route_Table		route_table;
		/** Netzwerk-Adress-&Uuml;bersetzung (NAT) zwischen zwei
		 *  Netzwerken, vor allem f&uuml;r TCP/UDP-Pakete */
		NAT			nat_packet_translator;

	private:
		void	intoInterface(IPv4_Packet *ip_packet);
		void	doRoute(double speed_factor);

	public:
		L3_Router_ExecuteNet();
		~L3_Router_ExecuteNet();

		void	executeNet(double speed_factor,
					double &direction_angle);
		void	importPacket(Packet* cable_packet);
};

