/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef ETHERNET_PACKET_H
#define ETHERNET_PACKET_H 1

#include <net/ethernet.h>

#include "macaddress.h"
#include "packet.h"

class Ethernet_Packet: public Packet
/** Klasse zur Beschreibung und Darstellung eines Ethernet-Packetes */
{
	protected:
		/** Daten im Kopf eines Ethernet-Packetes */
		struct ether_header	eth_header;

		void	updatePacketText(void);
	public:
		Ethernet_Packet(void);
		virtual ~Ethernet_Packet(void);
		virtual void	copy(Packet* &copy_of_packet);
		virtual void	loadXML(xmlTextReaderPtr infile);
		virtual void	saveXML(xmlTextWriterPtr outfile) const;

		void	importHeader(struct ether_header *new_eth_header);
		void	exportHeader(
				struct ether_header *current_eth_header) const;

		//@{ @name Adressen
		bool	setDestinationMacAddress(const char mac_string[]);
		bool	setSourceMacAddress(const char mac_string[]);
		void	setDestinationMacAddress(MacAddress address);
		void	setSourceMacAddress(MacAddress address);
		void	getDestinationMacAddress(MacAddress &address) const;
		void	getSourceMacAddress(MacAddress &address) const;
		//@}
};

#endif
