/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef ICMP_PACKET_H
#define ICMP_PACKET_H 1

#include <netinet/ip_icmp.h>

#include "ipv4_packet.h"

class ICMP_Packet : public IPv4_Packet
/** Klasse zur Beschreibung und Darstellung eines ICMP-Packetes,
 *  nicht vollst&auml;ndig implementiert */
{
	private:
		/** Daten im Kopf eines ICMP-Packetes */
		struct icmp	icmp_header;

		void		initPacketHeaders(void);
		void		updateIcmpChecksum(void);
		void		updatePacketText(void);

	public:
		ICMP_Packet(void);
		virtual ~ICMP_Packet(void);

		void	copy(Packet* &copy_of_packet);
		void	loadXML(xmlTextReaderPtr infile);
		void	saveXML(xmlTextWriterPtr outfile) const;

		void	importHeader(struct icmp *new_icmp_header);
		void	exportHeader(struct icmp *current_icmp_header) const;
};

#endif
