/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef IGMP_PACKET_H
#define IGMP_PACKET_H 1

#include <netinet/igmp.h>

#include "ipv4_packet.h"

class IGMP_Packet : public IPv4_Packet
/** Klasse zur Beschreibung und Darstellung eines IGMP-Packetes,
 *  nicht vollst&auml;ndig implementiert */
{
	private:
		/** Daten im Kopf eines IGMP-Packetes */
		struct igmp	igmp_header;

		void		initPacketHeaders(void);
		void		updateIgmpChecksum(void);
		void		updatePacketText(void);

	public:
		IGMP_Packet(void);
		virtual ~IGMP_Packet(void);

		void		copy(Packet* &copy_of_packet);
		void		loadXML(xmlTextReaderPtr infile);
		void		saveXML(xmlTextWriterPtr outfile) const;

		void		importHeader(struct igmp *new_igmp_header);
		void		exportHeader(struct igmp
						*current_igmp_header) const;

		//@{ @name IGMP-Einstellungen
		u_int8_t	getIgmpType(void) const;
		u_int8_t	getRoutingCode(void) const;
		void		getGroupAddress(IpAddress
							&group_address) const;

		void		setIgmpType(u_int8_t new_type);
		void		setRoutingCode(u_int8_t new_code);
		void		setGroupAddress(IpAddress group_address); 
		//@}
};

#endif
