/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef SERVICE_PACKET_H
#define SERVICE_PACKET_H 1

#include <string>

#include "packet.h"

using namespace std;

class Service_Packet : public Packet
/** Klasse zur Beschreibung und Darstellung eines Dienste-Packetes,
 *  Basisklasse f&uuml;r TCP_Service_Packet und UDP_Service_Packet */
{
	protected:
		/** Name des Dienstes, wird bei Bedarf zur Ermittlung der
		 *  Portnummer genutzt */
		string	service_name;	// /etc/services
		/** Gr&ouml;&szlig;e des Dateninhaltes in *data (in Bytes) */
		size_t	data_size;
		/** Zeiger auf beliebige Daten als Paketinhalt */
		void	*data;
	public:
		Service_Packet(void);
		virtual ~Service_Packet(void);
		virtual void	copy(Packet* &copy_of_packet);
		virtual void	loadXML(xmlTextReaderPtr infile);
		virtual void 	saveXML(xmlTextWriterPtr outfile) const;

		void		print(void);
		virtual void	setServiceName(const char new_service_name[]);
		virtual string	getServiceName(void);
};

#endif
