/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef TCP_SERVICE_PACKET_H
#define TCP_SERVICE_PACKET_H 1

#include "tcp_packet.h"
#include "service_packet.h"

class TCP_Service_Packet : public TCP_Packet, public Service_Packet
/** Klasse zur Beschreibung und Darstellung eines Dienste-Packetes mit
 *  TCP-Kopf, f&uuml;r die verbindungsorienterte Kommunikation */
{
	public:
		TCP_Service_Packet(void);
		~TCP_Service_Packet(void);
		void	copy(Packet* &copy_of_packet);
		void	loadXML(xmlTextReaderPtr infile);
		void	saveXML(xmlTextWriterPtr outfile) const;
		void	print(void);
		void	setServiceName(const char new_service_name[]);
		string	getServiceName(void);
};

#endif
