/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef UDP_PACKET_H
#define UDP_PACKET_H 1

#include <netinet/udp.h>

#include "ipv4_packet.h"

class UDP_Packet : public IPv4_Packet
/** Klasse zur Beschreibung und Darstellung eines UDP-Packetes */
{
	private:
		/** Daten im Kopf eines UDP-Packetes */
		struct udphdr	udp_header;

		void	initPacketHeaders(void);
		void	updateUdpChecksum(void);
		void	updatePacketText(void);
	public:
		UDP_Packet(void);
		virtual ~UDP_Packet(void);
		virtual void	copy(Packet* &copy_of_packet);
		virtual void	loadXML(xmlTextReaderPtr infile);
		virtual void	saveXML(xmlTextWriterPtr outfile) const;

		void		importHeader(struct udphdr *new_udp_header);
		void		exportHeader(struct udphdr
						*current_udp_header) const;
		unsigned short	getDestinationPort(void) const;
		unsigned short	getSourcePort(void) const;
		void		setDestinationPort(unsigned short dest_port);
		void		setSourcePort(unsigned short source_port);
};

#endif
