/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include "service.h"
#include "tcp_service_packet.h"

class HTTP_Service : public Service
/** einfacher Echo-Dienst, antwortet auf Pakete, die an bestimmten Port
 *  (siehe usesPort()) hereinkommen, soweit sie nicht vom selben Rechner sind
 *  (siehe in(): angegebene IpAdresse wird gepr&uuml;ft) */
{
	private:
		/** Liste der aktuell verwalteten Datenpakete, zur Zeit nur zum
		 *  zeitversetzten Senden genutzt */
		list<TCP_Service_Packet*>	data_packets;
	public:
		HTTP_Service(void);
		~HTTP_Service(void);
		bool	usesPort(unsigned short port_number,
					Protocol tcp_or_udp);
		void	init(void);
		void	in(Service_Packet* incoming_packet);
		void	out(Service_Packet* &outgoing_packet);
		void	loadXML(xmlTextReaderPtr infile);
		void	saveXML(xmlTextWriterPtr outfile);
};

