/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#ifndef SERVICE_H
#define SERVICE_H 1

#include <list>
#include <libxml/xmlreader.h>
#include <libxml/xmlwriter.h>

#include "service_packet.h"

using namespace std;

class Service
/** abstrakte Basisklasse f&uuml;r alle anderen Services (Dienste) */
{
	protected:

	public:
		Service(void);
		virtual ~Service(void);
		/** zeigt an, ob Dienst auf bestimmten Port und TCP oder UDP
		 *  lauscht */
		virtual bool	usesPort(unsigned short port_number,
						Protocol tcp_or_udp) = 0;
		/** laden von Paketen und Einstellungen aus XML-Datei infile */
		virtual void	loadXML(xmlTextReaderPtr infile) = 0;
		/** speichern von Paketen und Einstellungen in XML-Datei
		 *  outfile */
		virtual void	saveXML(xmlTextWriterPtr outfile) = 0;

		/** eingehende Datenpakete incoming_packet werden damit dem
		 *  Dienst &uuml;bergeben */
		virtual void	in(Service_Packet* incoming_packet) = 0;
		/** Dienst gibt hier seine zu sendenden Datenpakete heraus,
		 *  sonst NULL */
		virtual void	out(Service_Packet* &outgoing_packet) = 0;
};

#endif
