/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#ifdef WIN32

#include <windows.h>
// time.h for function time()
#include <time.h>

/** Zahl PI definiert (fehlt in Windows-Version der math.h) */
#ifndef M_PI
# define M_PI           3.14159265358979323846
#endif

#include <direct.h>

#ifndef MKDIR_FUNC
#define MKDIR_FUNC 1

/** Anlegen des Verzeichnisses 'name', nutzt mkdir(name), <br>
 *  implementiert in win_funcs.cpp */
extern void mkdir(const char *name, int rights);

#endif

#include <math.h>

#ifndef RINT_FUNC
#define RINT_FUNC 1

/** Funktion zum Runden einer Gleitkommazahl auf die n&auml;chste ganze Zahl, 
 *  implementiert in der Datei win_funcs.cpp */
extern double rint(double x);

#endif // RINT_FUNC

#ifndef USLEEP_FUNC
#define USLEEP_FUNC 1

/** Funktion zum Schlafenlegen eines Prozesses in Mikrosekunden-Zeit, 
 * implementiert in der Datei win_funcs.cpp */
extern void usleep(unsigned long time);

#endif	// USLEEP_FUNC

#ifndef SNPRINTF_FUNC
#define SNPRINTF_FUNC 1

/** macht die versteckte Funktion _snprintf verf&uuml;gbar mit dem richtigen
 *  Namen */
#define snprintf  _snprintf

#endif	// SNPRINTF_FUNC

#else

#include <unistd.h>

/** Windows kennt kein Typ 'long long' und man kann ihn auch nicht 
 * definieren. <br>
 * <br>
 * Die Datei stellt auerdem die Funktionen rint und usleep sowie die
 * Konstante M_PI zur Verfgung <br>
 * <br>
 * # define M_PI           3.14159265358979323846 <br>
 * Zahl PI definiert (fehlt in Windows-Version der math.h) <br>
 * <br>
 * extern double rint(double x); <br>
 * Funktion zum Runden einer Gleitkommazahl auf die nchste ganze Zahl, 
 * implementiert in der Datei win_funcs.cpp <br>
 * <BR>
 * extern void usleep(unsigned long time); <br>
 * Funktion zum Schlafenlegen eines Prozesses in Mikrosekunden-Zeit, 
 * implementiert in der Datei win_funcs.cpp <br>
 * <br>
 * #define snprintf  _snprintf <br>
 * macht die versteckte Funktion _snprintf verf&uuml;gbar mit dem richtigen
 * Namen <br>
 * <br>
 * extern void mkdir(const char *name, int rights); <br>
 * Anlegen des Verzeichnisses 'name', nutzt mkdir(name), <br>
 *  implementiert in win_funcs.cpp
 * */
typedef long long	LONGLONG;

#endif

