/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include "windows32.h"

#include "net_switch.h"

Net_Switch::Net_Switch(void)
/** Konstruktor, ist leer */
{
};

Net_Switch::~Net_Switch(void)
/** Destruktor, ist leer */
{
};

void Net_Switch::getInfos(Variable_Tree* &infos)
/** zur Zeit leer, <br>
 *  stellt den Variablenbaum f&uuml;r das Dialogfenster zusammen, Zeiger
 *  darauf in 'infos' zur&uuml;ck */
{
};

void Net_Switch::setInfos(Variable_Tree* infos)
/** zur Zeit leer, <br>
 *  liest die Werte aus dem Variablenbaum ein */
{
};

void Net_Switch::loadXML(xmlTextReaderPtr infile)
/** zur Zeit leer, <br>
 *  l&auml;dt die Einstellungen und Pakete des Switches aus der
 *  XML-Datei 'infile' */
{
};

void Net_Switch::saveXML(xmlTextWriterPtr outfile) const
/** zur Zeit leer, <br>
 *  speichert die Einstellungen und Pakete des Switches in die
 *  XML-Datei 'outfile' */
{
};

void Net_Switch::attachCable(Net_Cable *new_cable)
/** zur Zeit leer, <br>
 *  das Netzwerkkabel 'new_cable' soll mit dem Switch verbunden werden,
 *  damit dar&uuml;ber Pakete versandt werden k&ouml;nnen */
{
};

void Net_Switch::detachCables(void)
/** zur Zeit leer, <br>
 *  alle angeschlossenen Kabel entfernen, zur Neustrukturierung des Netzwerkes
 *  nach &Auml;nderung des Aufbaus */
{
};

bool Net_Switch::getFirstPacketPos(Point_3D &packet_pos) const
/** zur Zeit ohne Sinn, gibt nur 'false' zur&uuml;ck, <br>
 *  gibt die Position des 'untersten' (ersten) Paketes zur&uuml;ck, zur
 *  Fokussierung in der Animation;
 *  'true' wenn ein Paket vorhanden ist, sonst 'false' */
{
	bool	has_packets;

	has_packets = false;
	return has_packets;
};

void Net_Switch::executeNet(double speed_factor)
/** zur Zeit leer, <br>
 *  f&uuml;hrt ein Schritt der Netzwerksimulation im Switch aus,
 *  'speed_factor' beeinflusst die Geschwindigkeit der Drehung und des
 *  Pakettransports */
{
};

void Net_Switch::executeNetImportPacket(Packet* cable_packet)
/** zur Zeit leer, <br>
 *  importiert Paket in die Simulation, d.h. es kommt in eine Ethernet-
 *  Warteschlange zum Senden */
{
};

void Net_Switch::getName(string &node_name) const
/** zur Zeit leer, <br>
 *  gibt den Namen des Knotens zur&uuml;ck */
{
};

bool Net_Switch::hasIpAddress(IpAddress &searched_address) const
/** gibt nur 'false' zur&uuml;ck, da Switches keine IP-Adresse haben, <br>
 *  also auch nicht die gesuchte 'searched_address' */
{
	return false;
};

bool Net_Switch::hasMacAddress(MacAddress &searched_address) const
/** zur Zeit ohne Sinn, gibt nur 'false' zur&uuml;ck, <br>
 *  gibt 'true' zur&uuml;ck, wenn eine der Warteschlangen die Ethernet-Adresse
 *  'searched_address' hat, sonst 'false' */
{
	return false;
};

bool Net_Switch::needsTurn(void) const
/** zur Zeit ohne Sinn, gibt nur 'false' zur&uuml;ck, <br>
 *  gibt 'true' zur&uuml;ck, wenn sich der Switch drehen muss, um in die
 *  richtige Richtung zu senden, sonst 'false'; <br>
 *  zur Abstimmung zwischen den Kabeln und Knoten in der Animation */
{
	bool	needs_turn;

	needs_turn = false;
	return needs_turn;
};

void Net_Switch::getPos(double &current_centerx, double &current_centery,
			double &current_centerz) const
/** zur Zeit leer, <br>
 *  gibt die aktuelle Position des Switches zur&uuml;ck (Mittelpunkt des
 *  K&ouml;rpers), x / y / z */
{
};

void Net_Switch::getPosAngle(Point_3D &current_pos,
				double &current_angle) const
/** zur Zeit leer, <br>
 *  gibt die akutelle Position in 'current_pos' und den Rotationswinkel in
 *  'current_angle' zur&uuml;ck */
{
};

void Net_Switch::setColor(double new_red,  double new_green, double new_blue,
				double new_alpha)
/** zur Zeit leer, <br>
 *  setzt die Farbe, mit der der Switch dargestellt werden soll,
 *  Rot / Gr&uuml;n / Blau / Alpha(Transparenz) im Bereich 0.0 - 1.0 */
{
};

void Net_Switch::setPos(double new_centerx, double new_centery,
			double new_centerz)
/** zur Zeit leer, <br>
 *  setzt die Position des Switches (Mittelpunkt des K&ouml;rpers) */
{
};

void Net_Switch::setSize(double new_width, double new_height, double new_depth)
/** zur Zeit leer, <br>
 *  setzt die Gr&ouml;&szlig;e des Switches, Breite / H&ouml;he / Tiefe als
 *  Bounding-Box */
{
};

void Net_Switch::draw(void) const
/** zur Zeit leer, <br>
 *  zeichnet den Switch */
{
};

void Net_Switch::drawSetCameraPos(bool level_of_details_on,
					Point_3D camera_pos)
/** zur Zeit leer, <br>
 *  &uuml;bergibt dem Switch den aktuellen Zustand von Level of Detail (an/aus)
 *  'level_of_details_on' und die aktuelle Kameraposition 'camera_pos',
 *  zeichnet die internen Displaylisten neu, welche abh&auml;ngig von
 *  Level of Detail sind */

{
};

