/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include "checksums.h"
#include "icmp_packet.h"

ICMP_Packet::ICMP_Packet(void)
/** Konstruktor, Initialisierung: setProtocol(), initPacketHeaders() */
{
	setProtocol(3, ICMP);
	initPacketHeaders();
};

ICMP_Packet::~ICMP_Packet(void)
/** Destruktor, ist leer */
{
};

void ICMP_Packet::copy(Packet* &copy_of_packet)
/** ist zur Zeit leer, <br>
 *  kopiert den eigenen Paketkopf in den von copy_of_packet;
 *  copy_of_packet wird neu angelegt, wenn es ein NULL-Zeiger ist;
 *  sollte als Objekt der Klasse ICMP_Packet &uuml;bergeben werden, falls
 *  nicht NULL */
{
};

void ICMP_Packet::initPacketHeaders(void)
/** ist zur Zeit leer, <br>
 *  sollte die Felder des Paketkopfes auf initiale Werte setzen, auch den
 *  Protokolltyp und die L&auml;nge im IP-Kopf -> mit Checksumme */
{
};

void ICMP_Packet::updateIcmpChecksum(void)
/** berechnet die Pr&uuml;fsumme des Kopfes neu, ruft nur
 *  Checksums::updateIcmpChecksum() */
{
	// if icmp_packet is answer for an IP packet, the header and 64 bit of
	// content of that IP packet belongs to the ICMP packet and 
	// should (?) be included in calculation of checksum
	Checksums::updateIcmpChecksum(&icmp_header);
};

void ICMP_Packet::loadXML(xmlTextReaderPtr infile)
/** ist zur Zeit leer, <br>
 *  l&auml;dt Paketkopf aus XML-Datei 'infile', sollte
 *  IPv4_Packet::loadXML() rufen */
{
};

void ICMP_Packet::saveXML(xmlTextWriterPtr outfile) const
/** ist zur Zeit leer, <br>
 *  speichert Paketkopf in XML-Datei 'outfile', sollte
 *  IPv4_Packet::saveXML() rufen */
{
};

void ICMP_Packet::updatePacketText(void)
/** ist zur Zeit leer, <br>
 *  aktualisiert die dargestellte Paketbeschriftung im 3D-Fenster, aus
 *  den derzeitigen Daten im Paketkopf */
{
};

void ICMP_Packet::importHeader(struct icmp *new_icmp_header)
/** ist zur Zeit leer, <br>
 *  kopiert den Paketkopf von Zeiger 'new_icmp_header' in den intern
 *  gespeicherten Kopf, Beschriftung wird aktualisiert */
{
};

void ICMP_Packet::exportHeader(struct icmp *current_icmp_header) const
/** ist zur Zeit leer, <br>
 *  kopiert den internen Kopf in den Speicherbereich, auf den
 *  'current_icmp_header' zeigt */
{
};

