/******************************************************************************
* This file is part of netview 
* (an program to animate TCP/IP networks in 3D with OpenGL).
*
*    Copyright (C) 2004,2005 Stefan Ziegler.
*
*    netview is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    netview is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with netview; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/
#include "windows32.h"

#include <iostream>

#include "http_service.h"

/** very simple implementation */

HTTP_Service::HTTP_Service(void)
/** Konstruktor, leer */
{
};

HTTP_Service::~HTTP_Service(void)
/** Destruktor, l&ouml;scht alle Pakete in der Liste (Sendeschlange) */
{
	list<TCP_Service_Packet*>::iterator	all_packets;

	// cout << "destruktor HTTP_Service start" << endl;
	all_packets = data_packets.begin();
	while(all_packets != data_packets.end())
	{
		// cout << "Deleting: " << *all_packets << endl;
		if (*all_packets != NULL) delete (*all_packets);
		*all_packets = NULL;
		all_packets++;
	};
	data_packets.erase(data_packets.begin(), data_packets.end());
	// cout << "destruktor HTTP_Service end" << endl;
};

void HTTP_Service::init(void)
/* creates packet */
/** erzeugt Datenpakete, setzt sie in die Paketliste,
 *  derzeit leer (Inhalt auskommentiert) */
{
	// TCP_Service_Packet	*test_packet, *second_test_packet;

	// cout << "HTTP_Service::init start" << endl;
	// cout << sizeof(TCP_Service_Packet) << " " << sizeof(TCP_Packet) 
	// 	<< " " << sizeof(Service_Packet) << " " 
	//	<< sizeof(Packet) << endl;
	/* test_packet = NULL;
	second_test_packet = NULL;
	test_packet = new TCP_Service_Packet;
	if (test_packet != NULL)
	{
		// cout << "Packet: " << test_packet << endl;
		test_packet->setServiceName("http");
		test_packet->setDestinationPort(80);
		test_packet->setDestinationIpAddress("192.168.1.2");
		data_packets.insert(data_packets.end(), test_packet);		
	};*/
	/*second_test_packet = new TCP_Service_Packet;
	if (second_test_packet != NULL)
	{
		// cout << "Packet: " << test_packet << endl;
		second_test_packet->setServiceName("http");
		second_test_packet->setDestinationPort(18001);
		second_test_packet->setDestinationIpAddress("192.168.1.2");
		data_packets.insert(data_packets.end(), second_test_packet);
	};*/
	// cout << "HTTP_Service::init end" << endl;
};

void HTTP_Service::in(Service_Packet* incoming_packet)
/** eingegangenes Datenpaket wird umgeschrieben zur Antwort oder gel&ouml;scht,
 *  falls es von 192.168.1.2 kommt; Antwortpaket kommt ans Ende der Paketliste
 */
{
	unsigned short		source_port;
	IpAddress		source_address, test_address;
	TCP_Service_Packet	*test_packet;

	if (incoming_packet == NULL) return;
	cout << "HTTP_Service::in " << incoming_packet << endl;
	test_packet = reinterpret_cast<TCP_Service_Packet*>(incoming_packet);
	source_port = test_packet->getSourcePort();
	test_packet->setSourcePort(80);
	test_packet->setDestinationPort(source_port);
	test_packet->getSourceIpAddress(source_address);
	test_packet->setDestinationIpAddress(source_address.getAddress());
	// cout << "*** Source Address *** " << source_address;
	test_address.setAddress("192.168.1.2");
	if (!(source_address == test_address))
		data_packets.insert(data_packets.end(), test_packet);
	else delete test_packet;
};

void HTTP_Service::out(Service_Packet* &outgoing_packet)
/** Das erste Paket der Paketliste (zum Senden) wird dem Zeiger von
 *  outgoing_packet zugewiesen, und aus der Liste entfernt;
 *  gibt NULL-Zeiger, falls kein Paket vorhanden */
{
	TCP_Service_Packet*	first_packet;

	if (data_packets.size() > 0)
	{
		// cout << "Begin: " << *(data_packets.begin()) << " ";
		first_packet = *(data_packets.begin());
		// cout << "first_packet: " << first_packet << endl;
		outgoing_packet = reinterpret_cast<Service_Packet*>
					(first_packet);
		// cout << "Outgoing packet: " << outgoing_packet << endl;
		data_packets.erase(data_packets.begin());
	}
	else	outgoing_packet = NULL;
};

bool HTTP_Service::usesPort(unsigned short port_number, Protocol tcp_or_udp)
/** gibt 'true' zur&uuml;ck, falls angegebene Portnummer == 80 und tcp_or_udp
 *  auf TCP steht, zeigt an, das Dienst auf Port 80 TCP auf Pakete wartet;
 *  sonst 'false'. */
{
	cout << "HTTP_Service::usesPort " << port_number << " " 
		<< tcp_or_udp << endl;
	if ((port_number == 80) && (tcp_or_udp == TCP))
		return true;
	return false;
};

void HTTP_Service::loadXML(xmlTextReaderPtr infile)
/** zur Zeit leer, laden von Paketen und Einstellungen aus XML-Datei infile */
{
};

void HTTP_Service::saveXML(xmlTextWriterPtr outfile)
/** zur Zeit leer, speichern von Paketen und Einstellungen in XML-Datei outfile
 */
{
};

